﻿Imports System.Math

Public Class Form1

    Private Color_Error As Color = Color.FromArgb(255, 150, 150)

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Load_INI()
        LoadParams()
        EventsAreEnabled = True
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
    End Sub


    ' ===================================================================================
    '   MenuStrip and ToolStrip Gradients
    ' ===================================================================================
    Private Sub MenuStrip1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MenuStrip1.Paint
        Dim targetRect As New Rectangle(0, 0, _
                                        MenuStrip1.Width, MenuStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(targetRect, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Horizontal)
        e.Graphics.FillRectangle(brush, targetRect)
    End Sub
    Private Sub ToolStrip1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles ToolStrip1.Paint
        Dim targetRect As New Rectangle(0, 0, _
                                        ToolStrip1.Width, ToolStrip1.Height)
        Dim brush As New Drawing2D.LinearGradientBrush(targetRect, _
                                                       Color.White, _
                                                       Color.FromArgb(200, 200, 200), _
                                                       Drawing2D.LinearGradientMode.Vertical)
        e.Graphics.FillRectangle(brush, targetRect)
    End Sub


    ' ===================================================================================
    '   LED EVENTS
    ' ===================================================================================
    Private Sub txt_LedAngle_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedBeamAngle.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedLux()
        Calc_LedLumens()
        Calc_LedLightPower()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_LedMilliCandles_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedMilliCandles.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedLux()
        Calc_LedLumens()
        Calc_LedLightPower()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_LedLux_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedLux.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedMillicandlesFromLux()
        Calc_LedLumens()
        Calc_LedLightPower()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_LedLumen_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedLumen.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedMillicandles()
        Calc_LedLux()
        Calc_LedLightPower()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_LedLightPower_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedLightPower.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedLumensFromLightPower()
        Calc_LedMillicandles()
        Calc_LedLux()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_LedVoltage_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedVoltage.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedPower()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_LedCurrent_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedCurrent.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedPower()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_LedPower_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_LedPower.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_LedMilliAmperes()
        Calc_LedEfficiency()
        Calc_Array()
        EventsAreEnabled = True
    End Sub


    ' ===================================================================================
    '   LED CALC
    ' ===================================================================================
    Private Function Stearadians(ByVal angle As Double) As Double
        Dim stearad As Double
        If angle <= 180 Then
            stearad = (1 - Abs(Cos(angle / 2 * (Math.PI / 180)))) * 2 * Math.PI
        Else
            stearad = (1 + Abs(Cos(angle / 2 * (Math.PI / 180)))) * 2 * Math.PI
        End If
        'Debug.Print(stearad.ToString)
        Return stearad
    End Function
    Private Sub Calc_LedLux()
        txt_LedLux.NumericValue = txt_LedMilliCandles.NumericValue * 0.010764
        txt_LedLux.Refresh()
    End Sub
    Private Sub Calc_LedMillicandlesFromLux()
        txt_LedMilliCandles.NumericValue = txt_LedLux.NumericValue / 0.010764
        txt_LedLux.Refresh()
    End Sub
    Private Sub Calc_LedLumens()
        Dim Angle As Double = txt_LedBeamAngle.NumericValue
        Dim Mcd As Double = txt_LedMilliCandles.NumericValue
        txt_LedLumen.NumericValue = Stearadians(Angle) * (Mcd / 1000)
        txt_LedLumen.Refresh()
    End Sub
    Private Sub Calc_LedLumensFromLightPower()
        txt_LedLumen.NumericValue = txt_LedLightPower.NumericValue / 1000 * 683
        txt_LedLumen.Refresh()
    End Sub
    Private Sub Calc_LedLightPower()
        txt_LedLightPower.NumericValue = txt_LedLumen.NumericValue * 1000 / 683
        txt_LedLightPower.Refresh()
    End Sub
    Private Sub Calc_LedMillicandles()
        Dim Angle As Double = txt_LedBeamAngle.NumericValue
        Dim Lumen As Double = txt_LedLumen.NumericValue
        txt_LedMilliCandles.NumericValue = (1000 * Lumen) / Stearadians(Angle)
        txt_LedMilliCandles.Refresh()
    End Sub
    Private Sub Calc_LedMilliAmperes()
        txt_LedCurrent.NumericValue = txt_LedPower.NumericValue / txt_LedVoltage.NumericValue
        txt_LedCurrent.Refresh()
    End Sub
    Private Sub Calc_LedPower()
        txt_LedPower.NumericValue = txt_LedVoltage.NumericValue * txt_LedCurrent.NumericValue
        txt_LedPower.Refresh()
    End Sub
    Private Sub Calc_LedEfficiency()
        txt_LedEfficiency.NumericValue = txt_LedLumen.NumericValue * 1000 / txt_LedPower.NumericValue
        If txt_LedEfficiency.NumericValue > 683 Then
            txt_LedEfficiency.BackColor = Color_Error
        Else
            txt_LedEfficiency.BackColor = Color.LemonChiffon
        End If
        txt_LedEfficiency.Refresh()
    End Sub
    Friend Sub Calc_Led()
        Calc_LedLux()
        Calc_LedLumens()
        Calc_LedLightPower()
        Calc_LedPower()
        Calc_LedEfficiency()
    End Sub


    ' ===================================================================================
    '   Array EVENTS
    ' ===================================================================================
    Private Sub txt_ArrayResistors_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrayResistors.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_ArrayVoltageDrop_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrayVoltageDrop.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_ArrayResistors()
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_ArrayRows_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrayRows.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_ArrayColumns_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrayColumns.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_Array()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_ArraySupplyVoltage_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArraySupplyVoltage.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_ArrayFromSupplyVoltage()
        EventsAreEnabled = True
    End Sub
    Private Sub txt_ArrayAngle_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_ArrayBeamAngle.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        EventsAreEnabled = False
        Calc_Array()
        EventsAreEnabled = True
    End Sub


    ' ===================================================================================
    '   Array CALC
    ' ===================================================================================
    Private Sub Calc_ArrayResistors()
        txt_ArrayResistors.NumericValue = txt_ArrayVoltageDrop.NumericValue / (0.001 * txt_LedCurrent.NumericValue)
        txt_ArrayResistors.Refresh()
    End Sub
    Private Sub Calc_ArrayVoltageDrop()
        txt_ArrayVoltageDrop.NumericValue = 0.001 * txt_LedCurrent.NumericValue * txt_ArrayResistors.NumericValue
        txt_ArrayVoltageDrop.Refresh()
    End Sub
    Private Sub Calc_ArrayFromSupplyVoltage()
        txt_ArrayRows.NumericValue = Int(txt_ArraySupplyVoltage.NumericValue / txt_LedVoltage.NumericValue)
        txt_ArrayRows.Refresh()
        txt_ArrayVoltageDrop.NumericValue = txt_ArraySupplyVoltage.NumericValue - txt_ArrayRows.NumericValue * txt_LedVoltage.NumericValue
        txt_ArrayVoltageDrop.Refresh()
        Calc_ArrayResistors()
        Calc_ArraySupplyCurrent()
        Calc_ArraySupplyPower()
        Calc_ArrayResistorLosses()
        Calc_ArrayLumens()
        Calc_ArrayEquivalentIncandescentWatts()
        Calc_ArrayEfficiency()
        txt_ArrayRows.Refresh()
    End Sub
    Private Sub Calc_ArraySupplyVoltage()
        txt_ArraySupplyVoltage.NumericValue = txt_LedVoltage.NumericValue * txt_ArrayRows.NumericValue + txt_ArrayVoltageDrop.NumericValue
        txt_ArraySupplyVoltage.Refresh()
    End Sub
    Private Sub Calc_ArraySupplyCurrent()
        txt_ArraySupplyCurrent.NumericValue = txt_LedCurrent.NumericValue * txt_ArrayColumns.NumericValue
        txt_ArraySupplyCurrent.Refresh()
    End Sub
    Private Sub Calc_ArraySupplyPower()
        txt_ArraySupplyPower.NumericValue = txt_ArraySupplyVoltage.NumericValue * 0.001 * txt_ArraySupplyCurrent.NumericValue
        txt_ArraySupplyPower.Refresh()
    End Sub
    Private Sub Calc_ArrayResistorLosses()
        txt_ArrayResistorLosses.NumericValue = txt_ArrayVoltageDrop.NumericValue * 0.001 * txt_ArraySupplyCurrent.NumericValue
        txt_ArrayResistorLosses.Refresh()
    End Sub
    Private Sub Calc_ArrayLumens()
        Dim Angle As Double = txt_LedBeamAngle.NumericValue
        Dim Mcd As Double = txt_LedMilliCandles.NumericValue
        txt_ArrayLumens.NumericValue = txt_LedLumen.NumericValue * txt_ArrayRows.NumericValue * txt_ArrayColumns.NumericValue
        txt_ArrayLumens.Refresh()
    End Sub
    Private Sub Calc_ArrayEquivalentIncandescentWatts()
        Const Lamp100W_WattPerLumen As Double = 100 / 1500
        Const Lamp100W_IlluminatorCorrection As Double = 0.5
        Dim StearadiansCorrection As Double = 4 * PI / Stearadians(txt_ArrayBeamAngle.NumericValue)
        txt_ArrayEquivalentIncandescentWatt.NumericValue = txt_ArrayLumens.NumericValue * _
                                                            StearadiansCorrection * _
                                                            Lamp100W_WattPerLumen * _
                                                            Lamp100W_IlluminatorCorrection
        txt_ArrayEquivalentIncandescentWatt.Refresh()
    End Sub
    Private Sub Calc_ArrayEfficiency()
        txt_ArrayEfficiency.NumericValue = txt_ArrayLumens.NumericValue / txt_ArraySupplyPower.NumericValue
        If txt_ArrayEfficiency.NumericValue > 683 Then
            txt_ArrayEfficiency.BackColor = Color_Error
        Else
            txt_ArrayEfficiency.BackColor = Color.LemonChiffon
        End If
        txt_ArrayEfficiency.Refresh()
    End Sub
    Friend Sub Calc_Array()
        Calc_ArrayVoltageDrop()

        Calc_ArraySupplyVoltage()
        Calc_ArraySupplyCurrent()
        Calc_ArraySupplyPower()
        Calc_ArrayResistorLosses()

        Calc_ArrayLumens()
        Calc_ArrayEquivalentIncandescentWatts()
        Calc_ArrayEfficiency()
    End Sub


    ' ===================================================================================
    '   MENU
    ' ===================================================================================
    Private Sub Menu_Load_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Load.Click
        LoadFile()
    End Sub
    Private Sub Menu_Save_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Save.Click
        SaveParams()
    End Sub
    Private Sub Menu_SaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_SaveAs.Click
        SaveFileAs()
    End Sub
    Private Sub Menu_Instructions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Instructions.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\LedCal_Help_ENG.pdf""")
    End Sub
    Private Sub Menu_Doc1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Doc1.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Scales_ENG.pdf""")
    End Sub
    Private Sub Menu_Doc2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Doc2.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Devices_ENG.pdf""")
    End Sub
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog(Me)
    End Sub
    Private Sub Menu_Istruzioni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Istruzioni.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\LedCal_Help_ITA.pdf""")
    End Sub
    Private Sub Menu_ScaleDiMisura_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_ScaleDiMisura.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Scales_ITA.pdf""")
    End Sub
    Private Sub Menu_ApparecchiDiMisura_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_ApparecchiDiMisura.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Devices_ITA.pdf""")
    End Sub


    ' ===================================================================================
    '   TOOLSTRIP
    ' ===================================================================================
    Private Sub Tool_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Open.Click
        LoadFile()
    End Sub
    Private Sub Tool_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Save.Click
        SaveParams()
    End Sub
    Private Sub Tool_Instructions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Instructions.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\LedCal_Help_ENG.pdf""")
    End Sub
    Private Sub Tool_Doc1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Doc1.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Scales_ENG.pdf""")
    End Sub
    Private Sub Tool_Doc2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Doc2.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Devices_ENG.pdf""")
    End Sub
    Private Sub Tool_Istruzioni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_Istruzioni.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\LedCal_Help_ITA.pdf""")
    End Sub
    Private Sub Tool_ScaleDiMisura_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_ScaleDiMisura.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Scales_ITA.pdf""")
    End Sub
    Private Sub Tool_ApparecchiDiMisura_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_ApparecchiDiMisura.Click
        Process.Start("""" & Application.StartupPath & "\Docs\Helps\Measuring_Devices_ITA.pdf""")
    End Sub

End Class
